"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.state = exports.ApT = exports.apSW = exports.apS = exports.bindW = exports.bind = exports.bindTo = exports.Do = exports.flap = exports.flatten = exports.duplicate = exports.chainFirst = exports.apSecond = exports.apFirst = exports.Comonad = exports.extract = exports.Extend = exports.extend = exports.Semigroupoid = exports.compose = exports.Bifunctor = exports.mapLeft = exports.bimap = exports.Traversable = exports.sequence = exports.traverse = exports.Foldable = exports.reduceRight = exports.reduce = exports.foldMap = exports.Monad = exports.Chain = exports.chainW = exports.chain = exports.Applicative = exports.Apply = exports.ap = exports.Pointed = exports.of = exports.Functor = exports.map = exports.getMonoid = exports.getSemigroup = exports.cmd = exports.model = exports.fromModel = exports.URI = void 0;
const RO = __importStar(require("fp-ts-rxjs/lib/ReaderObservable"));
const Apply_1 = require("fp-ts/lib/Apply");
const Chain_1 = require("fp-ts/lib/Chain");
const function_1 = require("fp-ts/lib/function");
const Functor_1 = require("fp-ts/lib/Functor");
const Cmd_1 = require("./Cmd");
exports.URI = 'effe-ts/State';
const fromModel = (model) => [model, Cmd_1.none];
exports.fromModel = fromModel;
const model = (state) => state[0];
exports.model = model;
const cmd = (state) => state[1];
exports.cmd = cmd;
// -------------------------------------------------------------------------------------
// non-pipeables
// -------------------------------------------------------------------------------------
const _map = (ma, f) => (0, function_1.pipe)(ma, (0, exports.map)(f));
const _ap = (fab, fa) => (0, function_1.pipe)(fab, (0, exports.ap)(fa));
const _chain = (fa, f) => (0, function_1.pipe)(fa, (0, exports.chain)(f));
const _foldMap = M => (ae, f) => (0, function_1.pipe)(ae, (0, exports.foldMap)(M)(f));
const _reduce = (fa, b, f) => (0, function_1.pipe)(fa, (0, exports.reduce)(b, f));
const _reduceRight = (fa, b, f) => (0, function_1.pipe)(fa, (0, exports.reduceRight)(b, f));
const _mapLeft = (fa, g) => (0, function_1.pipe)(fa, (0, exports.mapLeft)(g));
const _bimap = (fa, f, g) => (0, function_1.pipe)(fa, (0, exports.bimap)(f, g));
const _extend = (fa, f) => (0, function_1.pipe)(fa, (0, exports.extend)(f));
const _traverse = (F) => (as, f) => {
    return F.map(f((0, exports.model)(as)), b => [b, (0, exports.cmd)(as)]);
};
const _compose = (ab, la) => (0, function_1.pipe)(ab, (0, exports.compose)(la));
// -------------------------------------------------------------------------------------
// instances
// -------------------------------------------------------------------------------------
const monoidReaderObservable = RO.getMonoid();
function getSemigroup(S) {
    return {
        concat: (x, y) => [S.concat((0, exports.model)(x), (0, exports.model)(y)), monoidReaderObservable.concat((0, exports.cmd)(x), (0, exports.cmd)(y))]
    };
}
exports.getSemigroup = getSemigroup;
function getMonoid(M) {
    return Object.assign(Object.assign({}, getSemigroup(M)), { empty: (0, exports.of)(M.empty) });
}
exports.getMonoid = getMonoid;
const map = f => ma => [f(ma[0]), ma[1]];
exports.map = map;
exports.Functor = {
    URI: exports.URI,
    map: _map
};
exports.of = exports.fromModel;
exports.Pointed = {
    URI: exports.URI,
    of: exports.of
};
const ap = fa => fab => [(0, exports.model)(fab)((0, exports.model)(fa)), monoidReaderObservable.concat((0, exports.cmd)(fab), (0, exports.cmd)(fa))];
exports.ap = ap;
exports.Apply = {
    URI: exports.URI,
    map: _map,
    ap: _ap
};
exports.Applicative = {
    URI: exports.URI,
    map: _map,
    ap: _ap,
    of: exports.of
};
const chain = f => ma => {
    const [b, s] = f((0, exports.model)(ma));
    return [b, monoidReaderObservable.concat((0, exports.cmd)(ma), s)];
};
exports.chain = chain;
exports.chainW = exports.chain;
exports.Chain = {
    URI: exports.URI,
    map: _map,
    ap: _ap,
    chain: _chain
};
exports.Monad = {
    URI: exports.URI,
    map: _map,
    ap: _ap,
    of: exports.of,
    chain: _chain
};
const foldMap = () => f => fa => f((0, exports.model)(fa));
exports.foldMap = foldMap;
const reduce = (b, f) => fa => f(b, (0, exports.model)(fa));
exports.reduce = reduce;
const reduceRight = (b, f) => fa => f((0, exports.model)(fa), b);
exports.reduceRight = reduceRight;
exports.Foldable = {
    URI: exports.URI,
    reduce: _reduce,
    foldMap: _foldMap,
    reduceRight: _reduceRight
};
const traverse = (F) => (f) => (as) => F.map(f((0, exports.model)(as)), b => [b, (0, exports.cmd)(as)]);
exports.traverse = traverse;
const sequence = (F) => (fas) => {
    return F.map((0, exports.model)(fas), a => [a, (0, exports.cmd)(fas)]);
};
exports.sequence = sequence;
exports.Traversable = {
    URI: exports.URI,
    map: _map,
    reduce: _reduce,
    foldMap: _foldMap,
    reduceRight: _reduceRight,
    traverse: _traverse,
    sequence: exports.sequence
};
const bimap = (f, g) => fa => [g((0, exports.model)(fa)), RO.Functor.map((0, exports.cmd)(fa), f)];
exports.bimap = bimap;
const mapLeft = f => ma => [(0, exports.model)(ma), RO.Functor.map((0, exports.cmd)(ma), f)];
exports.mapLeft = mapLeft;
exports.Bifunctor = {
    URI: exports.URI,
    bimap: _bimap,
    mapLeft: _mapLeft
};
const compose = la => ab => [(0, exports.model)(ab), (0, exports.cmd)(la)];
exports.compose = compose;
exports.Semigroupoid = {
    URI: exports.URI,
    compose: _compose
};
const extend = f => wa => [f(wa), (0, exports.cmd)(wa)];
exports.extend = extend;
exports.Extend = {
    URI: exports.URI,
    map: _map,
    extend: _extend
};
exports.extract = exports.model;
exports.Comonad = {
    URI: exports.URI,
    map: _map,
    extend: _extend,
    extract: exports.extract
};
exports.apFirst = 
/*#__PURE__*/
(0, Apply_1.apFirst)(exports.Apply);
exports.apSecond = 
/*#__PURE__*/
(0, Apply_1.apSecond)(exports.Apply);
exports.chainFirst = 
/*#__PURE__*/
(0, Chain_1.chainFirst)(exports.Chain);
exports.duplicate = 
/*#__PURE__*/
(0, exports.extend)(function_1.identity);
exports.flatten = (0, exports.chain)(function_1.identity);
exports.flap = 
/*#__PURE__*/
(0, Functor_1.flap)(exports.Functor);
// -------------------------------------------------------------------------------------
// do notation
// -------------------------------------------------------------------------------------
exports.Do = 
/*#__PURE__*/
(0, exports.of)({});
exports.bindTo = 
/*#__PURE__*/
(0, Functor_1.bindTo)(exports.Functor);
exports.bind = 
/*#__PURE__*/
(0, Chain_1.bind)(exports.Chain);
exports.bindW = exports.bind;
// -------------------------------------------------------------------------------------
// pipeable sequence S
// -------------------------------------------------------------------------------------
exports.apS = 
/*#__PURE__*/
(0, Apply_1.apS)(exports.Apply);
exports.apSW = exports.apS;
// -------------------------------------------------------------------------------------
// sequence T
// -------------------------------------------------------------------------------------
exports.ApT = 
/*#__PURE__*/
(0, exports.of)([]);
// -------------------------------------------------------------------------------------
// deprecated
// -------------------------------------------------------------------------------------
/**
 * @deprecated
 */
exports.state = Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, exports.Applicative), exports.Bifunctor), exports.Chain), exports.Comonad), exports.Extend), exports.Foldable), exports.Semigroupoid), exports.Traversable);
//# sourceMappingURL=State.js.map