import * as RO from 'fp-ts-rxjs/lib/ReaderObservable';
import { Applicative3 } from 'fp-ts/lib/Applicative';
import { Apply3 } from 'fp-ts/lib/Apply';
import { Chain3 } from 'fp-ts/lib/Chain';
import { Functor3 } from 'fp-ts/lib/Functor';
import { Monad3 } from 'fp-ts/lib/Monad';
import { Monoid } from 'fp-ts/lib/Monoid';
import { Pointed3 } from 'fp-ts/lib/Pointed';
import { Profunctor3 } from 'fp-ts/lib/Profunctor';
import * as Rr from 'fp-ts/lib/Reader';
import { Observable } from 'rxjs';
declare module 'fp-ts/lib/HKT' {
    interface URItoKind3<R, E, A> {
        'effe-ts/Sub': Sub<R, E, A>;
    }
}
export declare const URI = "effe-ts/Sub";
export declare type URI = typeof URI;
export interface Sub<R, Model, Action> extends Rr.Reader<Observable<Model>, RO.ReaderObservable<R, Action>> {
}
export declare function fromObservable<R, Model, Action>(actions$: Observable<Action>): Sub<R, Model, Action>;
export declare function fromCmd<R, Model, Action>(cmd: RO.ReaderObservable<R, Action>): Sub<R, Model, Action>;
export declare const none: Sub<unknown, unknown, never>;
export declare function getMonoid<R, Model, Action>(): Monoid<Sub<R, Model, Action>>;
export declare const map: <A, B>(f: (a: A) => B) => <R, M>(fa: Sub<R, M, A>) => Sub<R, M, B>;
export declare const Functor: Functor3<URI>;
export declare const of: Pointed3<URI>['of'];
export declare const Pointed: Pointed3<URI>;
export declare const ap: <R, E, A>(fa: Sub<R, E, A>) => <B>(fab: Sub<R, E, (a: A) => B>) => Sub<R, E, B>;
export declare const Apply: Apply3<URI>;
export declare const Applicative: Applicative3<URI>;
export declare const chain: <R, E, A, B>(f: (a: A) => Sub<R, E, B>) => (ma: Sub<R, E, A>) => Sub<R, E, B>;
export declare const Chain: Chain3<URI>;
export declare const Monad: Monad3<URI>;
export declare const promap: <R, E, A, D, B>(f: (d: D) => E, g: (a: A) => B) => (fea: Sub<R, E, A>) => Sub<R, D, B>;
export declare const Profunctor: Profunctor3<URI>;
export declare const apFirst: <R, E, B>(second: Sub<R, E, B>) => <A>(first: Sub<R, E, A>) => Sub<R, E, A>;
export declare const apSecond: <R, E, B>(second: Sub<R, E, B>) => <A>(first: Sub<R, E, A>) => Sub<R, E, B>;
export declare const chainFirst: <A, R, E, B>(f: (a: A) => Sub<R, E, B>) => (first: Sub<R, E, A>) => Sub<R, E, A>;
export declare const flatten: <R, E, A>(mma: Sub<R, E, Sub<R, E, A>>) => Sub<R, E, A>;
/**
 * @deprecated
 */
export declare const sub: Profunctor3<URI> & Monad3<URI>;
